clc; clear all; close all;

clc; clear all; close all;

fprintf('\n Plotting Figure 4a and Figure 4 b: This takes a minute or so \n');


gamma = 0.29;

% gamma = 1;


% 1. spending fixed at what value? 
%---------------------------------
s          = 1;
[A0,A1,A2] = get_model_capital_no_gov(gamma);
n          = length(A0);

% order of variables in vector y_t
mac  = 1;
kap  = 2; 
ivn  = 3; 
pin  = 4;    
con  = 5;
prk  = 6; 
out  = 7; 
lab  = 8; 
wag  = 9;
noi  = 10;
gov  = 11;

NAMES = [{'marginal cost','capital','investment','inflation','consumption','price of capital','output','labor','wage','nominal rate','government' }];

loc(1,1) = 10;  % which row is Taylor rule
loc(2,1) = noi; % which row in variable vector is interest rate
loc(3,1) = 11;  % which equaton is government spending in

% Now solve system conditional on exit

g0  = [[A0,-A2];[eye(n), zeros(n)]];           % coefficients on current period variables (including expectations of tomorrows variables as separate variables)
g1	= [[A1,zeros(n)];[zeros(n),eye(n)]];       % coefficients on last period variables
c   = zeros(2*n,1);                            % constant (not present in terminal regime)
psi = [zeros(n,1);zeros(n,1)];                 % coefficients on structural shocks 
pie = [zeros(n);eye(n)];                       % coefficients on expectational errors
div = 1;                                       % cutoff between explosive and non-explosive roots

addpath([cd,'\gensys']);
    [NA,c,NB,fmat,fwt,ywt,gev,eu] = gensys(g0,g1,c,psi,pie,div);
rmpath([cd,'\gensys']);

% Extract transition matrix (discard expectational variables that are of no interest here)
P = NA(1:n,1:n);

pgrid = 0 : 1/100 : 0.75;
mulitplier_stochatic = 0*pgrid;
mulitplier_deterministic = 0*pgrid;
dgrid = 0*pgrid;

for j = 1 : length(pgrid);

    p_stay = pgrid(j);
    p_exit = 1-p_stay;
    
    % now solve the system with stochastic exit
    
   % now solve the system with stochastic exit

    AA0 = A0; 
    AA1 = A1;
    AA2 = A2;

    AA0(loc(1),:)      = zeros(1,n);
    AA0(loc(1),loc(2)) = 1;
    AA1(loc(1),:)      = zeros(1,n);
    AA2(loc(1),:)      = zeros(1,n);

    g0  = [[AA0-p_exit*AA2*P,-(1-p_exit)*AA2];[eye(n), zeros(n)]];           % coefficients on current period variables (including expectations of tomorrows variables as separate variables)
    g1	= [[AA1,zeros(n)];[zeros(n),eye(n)]];       % coefficients on last period variables
    c   = [[zeros(n-1,1);s];zeros(n,1)];           % constant (not present in terminal regime)
    psi = zeros(2*n,1);                            % coefficients on structural shocks

    pie = [zeros(n);eye(n)];                       % coefficients on expectational errors
    div = 1;                   
    
    addpath([cd,'\gensys']);
    [NA,c,NB,fmat,fwt,ywt,gev,eu] = gensys(g0,g1,c,psi,pie,div);
    rmpath([cd,'\gensys']);
    
    if eu ~=[1;1]
        fprintf('\n indeterminacy \n');
    end
    
    % Extract transition matrix (discard expectational variables that are of no interest here)
    AA = NA(1:n,1:n);
    BB = NB(1:n,1);
    
    multiplier_stochastic(j) = 5*c(out);
    
    
    d = round(1/(1-p_stay));
    dgrid(j) = d;
    
    q = ones(d,1);
    
%    [Z,P,J] = solve_stacked(A0,A1,A2,d,loc,ones(d,1),q); 

    [Z,P,J] = solve_stacked_fiscal(A0,A1,A2,d,loc,ones(d,1),q); 
    
    
    IRF     = reshape(Z,n,d);
    multiplier_deterministic(j) = 5*IRF(out,1);

end;

FS = 12;
figure(1)
subplot(2,1,1)
plot(dgrid,multiplier_deterministic,'-r'); hold on; 
plot(1./(1-pgrid),multiplier_stochastic,'--b'); axis square;

h = xlabel('T');
set(h,'FontSize',FS);
h = ylabel('initial output multiplier');
set(h,'FontSize',FS);
l = legend('deterministic exit','stochastic exit','Orientation','horizontal','Location','SouthOutside');  
lp = get(l,'position');  set(l,'position',[lp(1) lp(2)/1.25 lp(3) lp(4)]);  % sets the legend farther down
set(l,'FontSize',12);
legend('boxoff');
if gamma == 0.29;
   print('-depsc','MSS_12_444_Figure_4a');
elseif gamma == 1;
   print('-depsc','MSS_12_444_Figure_4b'); 
end