clc; clear all; close all;

gamma = 0.29;
% gamma = 1;

% 1. Get model matrices
%----------------------
[A0,A1,A2] = get_model_capital_no_gov(gamma);

n          = length(A0);


grid =  [5 50 100 500 1000 5000];


multiplier_deterministic  = zeros(size(grid));

p_stay = 3/4;
p_exit = 1-p_stay;

% order of variables in vector y_t
mac  = 1;
kap  = 2; 
ivn  = 3; 
pin  = 4;    
con  = 5;
prk  = 6; 
out  = 7; 
lab  = 8; 
wag  = 9;
noi  = 10;
gov  = 11;

NAMES = [{'marginal cost','capital','investment','inflation','consumption','price of capital','output','labor','wage','nominal rate','government' }];

loc(1,1) = 10;  % which row is Taylor rule
loc(2,1) = noi; % which row in variable vector is interest rate
loc(3,1) = 11;  % which equaton is government spending in


 for j = 1 : length(grid);     
    d       = grid(j);
    s       = 1;
    q       = repmat(1-p_exit,d,1);
    [Z,P,J] = solve_stacked(A0,A1,A2,d,loc,s,q); 
    IRF     = reshape(Z,n,d);
    multiplier_deterministic(j) = 5*IRF(out,1);
    
    fprintf('\n Hybrid multiplier in model with captial of truncation %d is %2.2f \n',d,multiplier_deterministic(j));
   
 end;
 
 
 
