clc; clear all; close all;




fprintf('\n Table 3: linear stochastic exit multiplier \n')
fprintf('\n --------------------------------------------- \n')

sigma  = 2;
beta   = 0.99;
theta  = 0.85;
kappa  = (1-beta*theta)*(1-theta)/(theta);
s      = 0.2;
nu     = 1/2;


for t = 3:6
    p = (t-1)/t;
    multiplier = sigma*(  (1-p)*(1-beta*p) - kappa*p )/(  sigma*(1-p)*(1-beta*p) - kappa*(sigma + nu*(1-s))*p );
    fprintf('\n Multiplier of duration %d is %2.2f \n',t,multiplier);
end


fprintf('\n\n Table 3: linear deterministic exit multiplier \n')
fprintf('\n ----------------------------------------------- \n')


%--------------------------------------
% X_t = [c_t,pi_t]
c  = 1;
pi = 2;

% A0 X_t = A2 X_{t+1} + T0*G

A0 = zeros(2,2);
A2 = zeros(2,2);
T0 = zeros(2,1);

%1. pi = kappa*(sigma*c + nu*(1-s)*c + nu*s*g) + beta*pi(+1); 

A0(1,pi) = 1;
A0(1,c ) = -kappa*(sigma + nu*(1-s));
A2(1,pi) = beta;
T0(1,1 ) = kappa*nu*s;

% 2. sigma*c = sigma*c(+1) + pi(+1) // Household Euler
A0(2,c)  = sigma;
A2(2,c)  = sigma;
A2(2,pi) = 1;

A     = inv(A0)*A2;
theta = inv(A0)*T0;


for t = 3:6;
    X = (eye(2)-A)^(-1)*(eye(2)-A^t)*theta;
    multiplier = ((1-s)*X(1) + s)/s;
    fprintf('\n Multiplier of duration %d is %2.2f \n',t,multiplier);
end;
