clc; clear all; close all;

fprintf('\n  Computing solutions to nonlinear Rotemberg model \n');
fprintf('\n  Uses symbolic math and is really slow  \n');


global dg DL;

% setup = 'with shock';
setup = 'without shock';

switch setup
    case 'with shock'
    DL      = (1 + 2/100);
    case 'without shock' 
    DL      = (1 + 0/100);
end;

sigma   = 2;
beta    = 0.99;
phi     = 1/2;
theta   = 0.85;
kappa   = (1-beta*theta)*(1-theta)/(theta);
epsilon = 11;
acp     = (epsilon-1)/kappa;
s       = 0.2;
delta   = 10^(-2);
C_terminal = (1-s)^(phi/(phi+sigma));
Y_terminal = C_terminal^(-sigma/phi);
Pi_terminal = 1;

if DL == 1;
   R_constant=1/beta;
else
  R_constant  = 1;
end

tol = 10^(-10);

dg_keeper  = [0;delta];

Tmax = 6;

solution = zeros(Tmax,3,2);



for dg = [ 0 , 10^(-2)];

    syms Y Pin real
    G      = s*Y_terminal*(1+dg);
    C      = Y*(1-acp/2*(Pin-1)^2) - G;
    C      = eval(C);
    FOC_1  = -(epsilon-1) + (epsilon-1)*Y^phi*C^(sigma) - acp*(Pin-1)*Pin + DL*C_terminal^(-sigma)/C^(-sigma)*beta*acp*(Pi_terminal-1)*Pi_terminal*Y_terminal/Y;
    FOC_2  = C^(-sigma) - beta*DL*R_constant*C_terminal^(-sigma)*(1/Pi_terminal);
    
    out    = solve(FOC_1,FOC_2,Y,Pin);
    
    do_checks;
    
    solution_T = input('Pick a solution corresponding to these multipliers: enter 1,2,3 etc...');
    
    if dg == 0;
        solution(end,:,1) = SS0(solution_T,1:3);
    elseif dg == 10^(-2);
        solution(end,:,2) = SS1(solution_T,1:3);
    end;
    
    for T = 1 : Tmax-1;
        fprintf('\n Backing up to period T-%g \n',T);
        
        if dg == 0;
            Pin_next = solution(end-T+1,1,1);  % SS0(solution_T,1);
            Y_next  = solution(end-T+1,2,1);  % SS0(solution_T,2);
            C_next  = solution(end-T+1,3,1);  % SS0(solution_T,3);
        elseif dg == 10^(-2);
            Pin_next = solution(end-T+1,1,2);  % SS1(solution_T,1);
            Y_next   = solution(end-T+1,2,2);  % SS1(solution_T,2);
            C_next   = solution(end-T+1,3,2);  % SS1(solution_T,3);
        end;
        
        syms Y Pin real
        G     = s*Y_terminal*(1+dg);
        C     = Y*(1-acp/2*(Pin-1)^2) - G;
        C     = eval(C);
        FOC_1 = -(epsilon-1) + (epsilon-1)*Y^phi*C^(sigma) - acp*(Pin-1)*Pin + DL*C_next^(-sigma)/C^(-sigma)*beta*acp*(Pin_next-1)*Pin_next*Y_next/Y;
        FOC_2 = 1 - beta*DL*R_constant*((C/C_next)^sigma)*(1/Pin_next);
        out   = solve(FOC_1,FOC_2,Y,Pin);
        
      
        do_checks;
        
        solution_T = input('Pick a solution corresponding to these multipliers: enter 1,2,3 etc...');
        
        if dg == 0;
            solution(end-T,:,1) = SS0(solution_T,1:3);
        elseif dg == 10^(-2);
            solution(end-T,:,2) = SS1(solution_T,1:3);
        end;
        
    end;
    
end;


C0 = solution(:,3,1);
C1 = solution(:,3,2);



multiplier = (C1 + dg*s*Y_terminal -C0)./(dg*s*Y_terminal)
