clc; 
clear all; 
close all;



global p dg DL do_tim do_me

for T = [3,4,5,5.85472];

do_me   = 0;
do_tim  = 1 - do_me;
p       = (T-1)/T;
sigma   = 2;
beta    = 0.99;
phi     = 1/2;
theta   = 0.85;
kappa   = (1-beta*theta)*(1-theta)/(theta);
epsilon = 11;
if do_me == 1;
    acp     = epsilon/kappa;
elseif do_tim == 1;
    acp     = (epsilon-1)/kappa;
end;

s       = 0.2;
DL      = (1 + 2/100);
delta   = 10^(-2);

C_terminal = (1-s)^(phi/(phi+sigma));
Y_terminal = C_terminal^(-sigma/phi);
P_terminal = 1;

scale1 = 1;
scale2 = 1;

Parameters = [sigma; beta; acp; phi; epsilon];
options    = optimset('Display','Off','MaxFunEvals',10^9,'TolFun',10^(-16),'TolX',10^(-16),'MaxIter',10^8);
dg_keeper  = [0;delta];


for j = 0 : 1;
    dg     = dg_keeper(j+1);
    X      = zeros(1,2);
    X(1,1) = P_terminal*(1 - dg*scale1);
    X(1,2) = Y_terminal*(1 - dg*scale2);
    X_SS   = X;
    f      = @(X)Residual_Rotemberg_small(X,Parameters);
    [IRF,fval,exitflag,output,jacobian] = fsolve(f,X,options);
    if exitflag == 1;
        fprintf('\n fminsarch converged on solution \n');
    elseif exitflag == 0;
        fprintf('\n Maximum number of function evaluations or iterations was reached \n');
    end;
 %   fprintf('\n Maximum absolut deviation from equilibrium condition is %g, \n ', max(max(abs(Residual_Rotemberg_small(IRF,Parameters))))  );
    if j == 0
        SOL_0 = IRF;
    else
        SOL_1 = IRF;
    end;
end;



% multiplier = (SOL_1(2)-SOL_0(2))/(dg*s*Y_terminal);
% fprintf('\n Initial output multiplier is %g, \n ',  multiplier  );
G  = s*Y_terminal*(1+dg);
C0 = SOL_0(2)*(1-acp/2*(SOL_0(1)-1)^2) - s*Y_terminal; 
C1 = SOL_1(2)*(1-acp/2*(SOL_1(1)-1)^2) - G; 



multiplier = (C1 + dg*s*Y_terminal -C0)/(dg*s*Y_terminal);

fprintf('\n Initial consumption multiplier for duration of %2.4f periods is %2.2f, \n ',  T, multiplier  );

end