function multiplier = compute_multiplier(IRS)

% impulse response conditional on peg today
IR = cell2mat(IRS(2));

alpha  = 0.345;
beta   = 0.99;
delta  = 0.02;
GY     = 0.2;


% derived from steady state
KN = ((1/beta -1 + delta)/alpha)^(1/(alpha-1));
YK = KN^(alpha-1);
IY = delta/YK;
CK = YK*(1-GY) - delta;
CY = CK/YK;

% ordering of variables
kap  = 2; 
con  = 4;


Y = CY*IR(1,con) + IY/delta*IR(1,kap) + GY;

% convert to absolute changes (on impact)
multiplier = Y/GY;

