clear; clc;

disp('Fiscal mulitplier: model with capital, stochastic (absorbing) exit')
disp('==================================================================')

[A0,A1,A2,A3] = get_model_capital_MSRE;

[A,B,C] = normalize_MSRE(A0,A1,A2,A3);

R      = 1;   % AR(1) coefficient of spending shock

duration = 4;
p        = (duration-1)/duration; % prob(stay with constant rate regime)

pp     = 1;   % prob(stay with Tayor rule)

P(1,:) = [pp  ,1-pp];
P(2,:) = [1-p,   p]; 

% solve model
[DET,FCC,OmegaK,GammaK,FK, OtherInfo,IRS] = fmmsre(P,A,B,C,R);

D = run_diagnostics(DET,P,FK,FCC);

M = compute_multiplier(IRS);

fprintf('Fiscal multipier is %g',M);
