function [Residual] = Residual_Rotemberg_small(X,Parameters)

global p dg DL do_tim do_me

X = real(X);

T        = size(X,1);
Residual = ones(1,2);
sigma    = Parameters(1);
beta     = Parameters(2);
acp      = Parameters(3);
phi      = Parameters(4);
epsi     = Parameters(5);
tau      = epsi/(epsi-1);
Pin      = X(1);
Y        = X(2);


s           = 0.2;
C_terminal  = (1-s)^(phi/(phi+sigma));
Y_terminal  = C_terminal^(-sigma/phi);
Pi_terminal = 1;

if DL == 1 
   R_terminal  = 1/beta;
   R_constant  = 1/beta;
else
   R_terminal  = 1;
   R_constant  = 1;
end

G = s*Y_terminal*(1+dg);
C = Y*(1-acp/2*(Pin-1)^2) - G;

% 1. FOC price setting
if do_me == 1;
Residual(1) = -(epsi-1)*tau*C^(-sigma)*Y + epsi*Y^phi*C^sigma*C^(-sigma)*Y - acp*(Pin-1)*Pin*C^(-sigma)*Y + ...
                        p*C^(-sigma)*DL*beta*acp*(Pin-1)*Pin*Y + ...
                   (1-p)*C_terminal^(-sigma)*DL*beta*acp*(Pi_terminal-1)*Pi_terminal*Y_terminal;
elseif do_tim == 1;
Residual(1) = -(epsi-1)*C^(-sigma)*Y + (epsi-1)*Y^phi*C^sigma*C^(-sigma)*Y - acp*(Pin-1)*Pin*C^(-sigma)*Y + ...
                        p*C^(-sigma)*DL*beta*acp*(Pin-1)*Pin*Y + ...
                   (1-p)*C_terminal^(-sigma)*DL*beta*acp*(Pi_terminal-1)*Pi_terminal*Y_terminal;
end;
               
% 2. Euler equation
% Residual(2) = C^(-sigma) - p*beta*DL*R_constant*C^(-sigma)/Pin - (1-p)*DL*beta*R_constant*C_terminal^(-sigma)/Pi_terminal;

Residual(2) = C^(-sigma) - p*beta*DL*R_constant*C^(-sigma)/Pin - (1-p)*C_terminal^(-sigma)/Pi_terminal;



Residual = Residual.*[1,1];