
    % eliminate spurious solutions
    check_1 = subs(FOC_1, {Y,Pin}, {out.Y,out.Pin});
    check_2 = subs(FOC_2, {Y,Pin}, {out.Y,out.Pin});
    index   = find( (abs(double(check_1)) <tol) & (abs(double(check_2)) <tol) );
    
    if dg == 0
        Y0 = double(out.Y(index));
        P0 = double(out.Pin(index));
    elseif dg == 10^(-2)
        Y1 = double(out.Y(index));
        P1 = double(out.Pin(index));
    end


% eliminate complex solutions, negative price levels or negative output
index1 = [];
index0 = [];

if dg == 10^(-2);
   sols = length(Y1);
elseif dg == 0;
   sols = length(Y0);
end

for k = 1: sols;
    if dg == 10^(-2)
        check1 = isreal(P1(k)) & P1(k)>0 & isreal(Y1(k)) & Y1(k)> 0;
        if check1 == 1;
            index1 = [index1,k];
        end
    elseif dg == 0;
        check0 = isreal(P0(k)) & P0(k)>0 & isreal(Y0(k)) & Y0(k)> 0;
        if check0 == 1
            index0 = [index0,k];
        end;
    end;
end;

if dg == 10^(-2)
    % work out consumption
    S1 = [P1(index1),Y1(index1),0*Y1(index0)];
    for j= 1:length(index1);
        S1(j,3) = S1(j,2)*(1-acp/2*(S1(j,1)-1)^2) - (1+dg)*s*Y_terminal ;
    end
    % make sure all values  are positive
    
    SS1 = S1(all(S1(:,:)>0,2)==1,:);
    SS1 = sort(SS1,1)
elseif dg == 0
    % work out consumption
    S0 = [P0(index0),Y0(index0),0*Y0(index0)];
    for j= 1:length(index0);
        S0(j,3) = S0(j,2)*(1-acp/2*(S0(j,1)-1)^2) - s*Y_terminal;
    end;
    
    SS0 = S0(all(S0(:,:)>0,2)==1,:);
    SS0 = sort(SS0,1)
end